package beskeder;
import medier.*;
import java.util.*;
public class BeskedSender
{
  private static BeskedSender beskedSender;
  private BeskedSender ()
  {
  }
  public static BeskedSender getBeskedSender ()
  {
    if (beskedSender == null)
      beskedSender = new BeskedSender();
    return beskedSender;
  }
  private SenderAdapter getSender(Medie medie)
  {
    if (medie instanceof MailMedie)
       return new MailSender();
    return null;
  }

  public void send(Iterator medieIterator, Object besked)
  {
    if (!medieIterator.hasNext())  // afbryd hvis ingen medier
      return;

    Medie medie = (Medie)medieIterator.next();
    SenderAdapter sender = getSender(medie);
    sender.send(medie, besked);
  }

}
