package kerne;

import java.util.*;

public class Efterspoergsel {

	private static final int STATUS_IKKE_ANKOMMET = 0;
	private static final int STATUS_ANKOMMET = 1;
	private static final int STATUS_UINFORMERET = 0;
	private static final int STATUS_SET = 1;
	private static final int STATUS_KASSERET = 2;

    private Date   tidspunkt;
	private Person efterspoerger;
	private Person efterspurgte;
	private int statusForEfterspoerger; // aktiv / set / inaktiv
	private int statusForEfterspurgte;	// aktiv / inaktiv

		public Efterspoergsel(Person efterspoerger, Person efterspurgte)
		{
                tidspunkt = new Date();
				statusForEfterspoerger = STATUS_IKKE_ANKOMMET;
				statusForEfterspurgte = STATUS_UINFORMERET;
				this.efterspoerger = efterspoerger;
				this.efterspurgte = efterspurgte;
				efterspoerger.addEgenEfterspoergsel(this);
		}

		public Person getEfterspoerger() {
	return efterspoerger;
		}


		public Person getEfterspurgte() {
	return efterspurgte;
		}

		public void setAnkommet() {
	statusForEfterspoerger = STATUS_ANKOMMET;
		}

		public void setSet() {
	statusForEfterspurgte = STATUS_SET;
		}
        
		public void setKasseret() {
	statusForEfterspurgte = STATUS_KASSERET;
		}
        
		public boolean isAnkommet() {
	return statusForEfterspoerger == STATUS_ANKOMMET;
		}

		public boolean isNy() {
	return statusForEfterspurgte == STATUS_UINFORMERET;
		}

		public boolean isSet() {
	return statusForEfterspurgte == STATUS_SET;
		}

		public boolean isKasseret() {
	return statusForEfterspurgte == STATUS_KASSERET;
		}
        
   public String toString () {
      return "tidspunkt:"+tidspunkt
             +" efterspoerger:"+efterspoerger + " efterspurgte:"+ efterspurgte
             +" statusForEfterspoerger:"+ statusForEfterspoerger
             +" statusForEfterspurgte:"+statusForEfterspurgte;
   }

}
