package kerne;

import java.util.*;
public class Kerne
{
		private static Kerne kerne; // singleton

		private HashMap omraader = new HashMap();
		private HashMap personer = new HashMap();
		private Collection moeder = new Vector();


		private Kerne() {
		}


		public static Kerne getKerne() {
	if (kerne == null)
			kerne = new Kerne();
	return kerne;
		}

		public void opretPerson(String personID, String navn, String adresse) {
	Person person = new Person(personID, navn, adresse, null);
	personer.put(personID, person);
		}

		public Iterator getPersonIterator() {
	return personer.values().iterator();
		}

		public Person getPerson(String personID) {
	return (Person) personer.get(personID);
		}


		public void opretOmraade(String omraadeID, int stoerelse) {
	Omraade omraade = new Omraade(omraadeID, stoerelse);
	omraader.put(omraadeID, omraade);
		}

		public Iterator getOmraadeIterator() {
	return omraader.values().iterator();
		}

		public Omraade getOmraade(String omraadeID) {
	return (Omraade) omraader.get(omraadeID);
		}


		public Moede opretMoede() {
	Moede moede = new Moede();
	moeder.add(moede);
	return moede;
		}

		public Iterator getMoedeIterator() {
	return moeder.iterator();
		}
}
