package kerne;

import java.util.*;
import medier.*;
import beskeder.*;
public class Person
{
		private String personID;
		private String navn;
		private String adresse;
		
		private Omraade iOmraade;
		private Collection forladteOmraader = new Vector();
		private Collection egneEfterspoergsler = new Vector();
		private Collection andresEfterspoergsler = new Vector();

		private Collection ansvarligForMoeder = new Vector();
		private Collection deltagerIMoeder = new Vector();
		private Collection medier = new Vector();

		protected Person(String personID, String navn, String adresse, Omraade iOmraade) 
		{
	this.personID = personID;
	this.navn = navn;
	this.adresse = adresse;
	this.iOmraade = iOmraade;
		}

		public void skiftOmraade (Omraade nyOmraade)
		{
	if (iOmraade != null)			// af hensyn til opstart 1. gang
			{
					ForladtOmraade forladtOmraade = new ForladtOmraade(this, this.iOmraade);
		this.forladteOmraader.add(forladtOmraade);
			}
	this.iOmraade = nyOmraade;
		}

		public void oplysOmAnkomst()	
		{
	Iterator efterspoergerListe = andresEfterspoergsler.iterator();
	while (efterspoergerListe.hasNext())
			{
		Efterspoergsel efterspoergsel = (Efterspoergsel)efterspoergerListe.next();
		Person efterspoerger = efterspoergsel.getEfterspoerger();
		efterspoergsel.setAnkommet();
		efterspoerger.sendAnkomstmeddelelse(efterspoergsel);
		if (efterspoergsel.isKasseret())
			 andresEfterspoergsler.remove(efterspoergsel); //problem p.g.a iterator
			}
		}

		protected void sendAnkomstmeddelelse(Efterspoergsel efterspoergsel)
		{
				if (this.egneEfterspoergsler.contains(efterspoergsel))
				{
                    BeskedSender sender = BeskedSender.getBeskedSender();
                    String besked = ""+efterspoergsel.getEfterspurgte()+" er ankommet";
			        sender.send(this.getMedieIterator(), besked);
					this.egneEfterspoergsler.remove(efterspoergsel);
				}
		}


		public Omraade getOmraade() {
	return iOmraade;
		}


		public void opretEfterspoergsel(Person efterspoerger) {
			Efterspoergsel efterspoergsel = new Efterspoergsel(efterspoerger, this);
				andresEfterspoergsler.add(efterspoergsel);
		}
		public void opretAnkomstMeddelelse(Person efterspoerger) {
			Efterspoergsel efterspoergsel = new Efterspoergsel(efterspoerger, this);
				efterspoergsel.setKasseret();
				andresEfterspoergsler.add(efterspoergsel);
		}


		protected void addEgenEfterspoergsel(Efterspoergsel efterspoergsel) {
		egneEfterspoergsler.add(efterspoergsel);
		}


		// med for test
		public Iterator getForladtOmraadeIterator()
		{
	return forladteOmraader.iterator();
		}


		public Iterator getEgneEfterspoergselIterator() {
	return egneEfterspoergsler.iterator();
		}


		public Iterator getAndresEfterspoergselIterator() {
	return andresEfterspoergsler.iterator();
		}


		public Iterator getAnsvarligForMoederIterator() {
	return ansvarligForMoeder.iterator();
		}


		public Iterator getDeltagerIMoederIterator() {
	return deltagerIMoeder.iterator();
		}


		public boolean konflikt(Date start, Date slut) {
	Iterator moedeListe = deltagerIMoeder.iterator();
	boolean conflict = false;

	while (moedeListe.hasNext()) {
			Moede moede = (Moede) moedeListe.next();
			Date mstart = moede.getStart();
			Date mslut = moede.getSlut();
			
			if (mstart.compareTo(start) < 0 && mslut.compareTo(start) > 0) { //(mstart < start && mslut > start)
		conflict = true;
			} else if (mstart.compareTo(start) > 0 && mstart.compareTo(slut) < 0) { //(mstart > start && mstart < slut)
		conflict = true;
			}
	}
	return conflict;
		}


		public void addDeltagerIMoede(Moede moede) {
	deltagerIMoeder.add(moede);
		}


		public void addAnsvarligForMoeder(Moede moede) {
	ansvarligForMoeder.add(moede);
		}

		
		public String toString()
		{
	return "Person:"+personID+", "+navn+", "+adresse;
		}


		public Iterator getNyEfterspoergselIterator() {
				Collection nyeEfterspoergsler = new Vector();
				Iterator efterspoerselsIterator = getAndresEfterspoergselIterator();
				while (efterspoerselsIterator.hasNext())
				{
			Efterspoergsel efterspoergsel = (Efterspoergsel)efterspoerselsIterator.next();
			if (efterspoergsel.isNy())
					nyeEfterspoergsler.add(efterspoergsel);
				}
				return nyeEfterspoergsler.iterator();
		}

		public Iterator getSetEfterspoergselIterator() {
				Collection seteEfterspoergsler = new Vector();
				Iterator efterspoerselsIterator = getAndresEfterspoergselIterator();
				while (efterspoerselsIterator.hasNext())
				{
			Efterspoergsel efterspoergsel = (Efterspoergsel)efterspoerselsIterator.next();
			if (efterspoergsel.isSet())
					seteEfterspoergsler.add(efterspoergsel);
				}
				return seteEfterspoergsler.iterator();
		}
		public void addMedie(Medie medie)
		{
		  medier.add(medie);
		}

		public Iterator getMedieIterator()
		{
		  return medier.iterator();
		}



}
