package test;
import usecaseFacade.*;
import kerne.*;
import java.util.*;
public class UseCaseTest
{
  public static void personAnkommer()
  {
    System.out.println("============================================================");
    System.out.println("Start: test af usecase person ankommer");
    Doermand.personAnkommer("p03", "o200");
    Doermand.personAnkommer("p03", "o100");
    Doermand.personAnkommer("p03", "o210");
    Doermand.personAnkommer("p01", "o100");
    TestDataUdskrifter.visAllePersonersForladteOmraader();
    System.out.println("Slut: Test af usecase person ankommer");
    System.out.println("============================================================");
  }
  public static void personSkifterOmraade()
  {
    System.out.println("============================================================");
    System.out.println("Test af usecase person skifter omrde");
    Doermand.personSkifterOmraade("p03", "o200");
    Doermand.personSkifterOmraade("p03", "o100");
    Doermand.personSkifterOmraade("p03", "o210");
    Doermand.personSkifterOmraade("p01", "o100");
    TestDataUdskrifter.visAllePersonersForladteOmraader();
    System.out.println("Slut: Test af usecase person skifter omrde");
    System.out.println("============================================================");
  }

  public static void moedeplanlaegning()
  {
    System.out.println("============================================================");
    System.out.println("Test af usecase mde planlgning");
    MoedePlanlaegning  moedePlanlaegning = new MoedePlanlaegning();
    moedePlanlaegning.angivMoedeAnsvarlig("p01");
    moedePlanlaegning.tilfoejDeltager("p01");
    moedePlanlaegning.tilfoejDeltager("p02");
    moedePlanlaegning.tilfoejDeltager("p03");
    moedePlanlaegning.angivDeltagerAntal(3);
    moedePlanlaegning.angivStartSlut(new Date(), new Date());
    moedePlanlaegning.angivOmraade("o210");
    moedePlanlaegning.afslutMoedeOprettelse();

    TestDataUdskrifter.visAllePersonersMoeder();
    System.out.println("Slut: Test af usecase mde planlgning");
    System.out.println("============================================================");
  }


  public static void efterspoergPerson()
  {
    System.out.println("============================================================");
    System.out.println("Test af usecase eftersprg person");
    Omraade omraade = Doermand.efterspoergPerson("p03");
    System.out.println("efterspurgt person p03 er i omrde: "+omraade);
    Doermand.registrerEfterspoergsel("p03", "p01");
    TestDataUdskrifter.visAllePersonersEfterspoergsler();
    System.out.println("Slut: Test af usecase eftersprg person");
    System.out.println("============================================================");
  }

  public static void sendBesked()
  {
    System.out.println("============================================================");
    System.out.println("Test af usecase sendBesked");
    Doermand.sendBesked("p03", "Hej med dig");
    System.out.println("Slut: Test af usecase sendBesked");
    System.out.println("============================================================");
  }

  public static void checkAndresEfterspoergseler()
  {
    System.out.println("============================================================");
    System.out.println("Test af usecase behandling af andres eftersprgsler");
    checkAndresEfterspoergseler("p01");
    System.out.println("Test igen for at se ny status");
    checkAndresEfterspoergseler("p01");
    System.out.println("Test igen igen for at se om der blev kaseret");
    checkAndresEfterspoergseler("p01");
    System.out.println("Slut: Test af usecase behandling af andres eftersprgsler");
    System.out.println("============================================================");
  }
  public static void checkAndresEfterspoergseler(String personID)
  {
    System.out.println("============================================================");
    System.out.println("Test af behandling af andres eftersprgsler");
    System.out.println(""+personID+": er efterspurgt af");
    EfterspoergselsBehandler efterspoergselsBehandler
               = new EfterspoergselsBehandler (personID);
    while (efterspoergselsBehandler.flereNye ())
    {
       Efterspoergsel efterspoergsel = efterspoergselsBehandler.nextNye();
       System.out.println("Nye efterspergseler: "+efterspoergsel);
    }
    
    while (efterspoergselsBehandler.flereSete ())
    {
       Efterspoergsel efterspoergsel = efterspoergselsBehandler.nextSete();
       System.out.println("Tidligere sete efterspergseler: "+efterspoergsel);
       efterspoergselsBehandler.kasser();
    }
    System.out.println("Slut: Test af behandling af andres eftersprgsler");
    System.out.println("============================================================");
  }






}
