package usecaseFacade;
import kerne.*;
import java.util.*;

public class MoedePlanlaegning {
		private Moede moede;

		public MoedePlanlaegning() {
	this.moede = Kerne.getKerne().opretMoede();
		}

		//Pre-betingelse person skal eksistere med personID.
		public void angivMoedeAnsvarlig(String personID) {
	Person ansvarlig = Kerne.getKerne().getPerson(personID);
	ansvarlig.addAnsvarligForMoeder(moede);
	moede.setAnsvarlig(ansvarlig);
		}


		//Pre-betingelse person skal eksistere med personID.
		public void tilfoejDeltager(String personID) {
	Person deltager = Kerne.getKerne().getPerson(personID);
	deltager.addDeltagerIMoede(moede);
	moede.addDeltager(deltager);	
		}
		
		//Pre-betingelse antal >= 0
		public void angivDeltagerAntal(int antal) {
	moede.setAntalDeltagere(antal);
		}

		//Pre-betingelse start < slut
		public void angivStartSlut(Date start, Date slut) {
	moede.setStartSlut(start, slut);
		}


		public Iterator visKonfliktPersoner() {
	return moede.visKonflikter();
		}


		public Iterator visLedigeOmraader() {
	/*
		Don't pass Omraader as Iterator in method-call;
		It's better to call the kernel for these general informations.
		This give's a more general freedom to change the function in the
		future, without changing the function-call.
		Since the kernel is made as a single-ton the kernel doesn't have to 
		be passed with as a parameter.
	*/

	Iterator omraader = Kerne.getKerne().getOmraadeIterator();
	AbstractCollection omraaderOK = new Vector();

	while (omraader.hasNext()) {
			Omraade omraade = (Omraade) omraader.next();

			if (omraade.isStortLedigt(moede.getAntalDeltagere(), moede.getStart(), moede.getSlut()))
		/*
		if (omraade.getStoerrelse() > moede.getAntalDeltagere())
		//Check needed for availability (no method in Omraade-class to see if there are any meeting? Iteration is a bad idea.
		*/
		omraaderOK.add(omraade);
	}

	return omraaderOK.iterator();
		}

		//Pre-betingelse omraade med omraadeID skal eksistere
		public void angivOmraade(String omraadeID) {
	Omraade omraade = (Omraade) Kerne.getKerne().getOmraade(omraadeID);
	moede.setOmraade(omraade);
	omraade.addMoede(moede);
		}


		public void afslutMoedeOprettelse() {
	moede.setOprettet(true);
		}
}
